package jp.webedi.sfi.bizx.server.adapter;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import jp.webedi.sfi.bizx.server.commons.Constant;
import jp.webedi.sfi.bizx.server.communication.*;

public class NativeConnectorImpl implements INativeConnector {
	
	private static final String SLASH_STR = "/";
	private static final String WEBXML_FILE_PATH = File.separator + "webapps" + File.separator + "axis" + File.separator + "WEB-INF" + File.separator + "web.xml";
	private static final String INIT_CONF_FOLDER = File.separator + "conf" + File.separator;
	private static int subno = 0;
	private static boolean initComplete = false;
//	private static Document xdoc;
	
	/**
	 * $$ 
	 * @param iteminfo
	 * @throws Exception
	 */
	public void putDocument( IItemInfo iteminfo ) throws Exception {
		JXMSTransferSoap jxms = new JXMSTransferSoap();
		String subCode = null;
		try {
			// 
			iteminfo.setConnectType( INativeConnector.PUT_DOCUMENT );
			// եΥѥ
			NativeConnectorImpl.setConfigFilePath();
			// åIDǼƤʤмư
			if ( iteminfo.getMessageId() == null ) {
				// åID
				++subno;
				if ( subno > 9999 ) {
					subno = 1;
				}
				subCode = "0000" + String.valueOf( subno );
				subCode = subCode.substring( ( subCode.length() - 4 ) );
				iteminfo.setMessageId( NativeConnectorImpl.getCurDateString( Constant.TIME_STR_YYYYMMDDHHMMSSFFF ) + "." + subCode + ItemInfoImpl.getFromId().trim() );
			}
			// PutDocument¹
			boolean rc = jxms.putDocument( iteminfo );
			if ( rc ) {
				iteminfo.setResultInfo( IItemInfo.STATUS_OK );
			} else {
				iteminfo.setResultInfo( IItemInfo.STATUS_DOUBLE );
			}
		} catch ( Exception ex ) {
			iteminfo.setResultInfo( IItemInfo.STATUS_NG );
			iteminfo.setRetryStatus( evaluatedForRetry( ex.getMessage() ) );
			iteminfo.setMessageId( null );
			throw ex;
		} finally {
			System.gc();
		}
	}
	
	/**
	 * $$ 
	 * @param iteminfo
	 * @throws Exception
	 */
	public void getDocument( IItemInfo iteminfo ) throws Exception {
		JXMSTransferSoap jxms = new JXMSTransferSoap();
		try {
			// 
			iteminfo.setConnectType( INativeConnector.GET_DOCUMENT );
			// եΥѥ
			NativeConnectorImpl.setConfigFilePath();
			// GetDocument¹
			boolean rc = jxms.getDocument( iteminfo );
			if ( rc ) {
				iteminfo.setResultInfo( IItemInfo.STATUS_OK );
			} else {
				iteminfo.setResultInfo( IItemInfo.STATUS_DOUBLE );
			}
		} catch ( Exception ex ) {
			iteminfo.setResultInfo( IItemInfo.STATUS_NG );
			iteminfo.setRetryStatus( evaluatedForRetry( ex.getMessage() ) );
			throw ex;
		} finally {
			System.gc();
		}
	}
	
	/**
	 * $$ åIDꥹȼ
	 * @param iteminfo
	 * @throws Exception
	 */
	public void getDocumentList( IItemInfo iteminfo ) throws Exception {
		JXMSTransferSoap jxms = new JXMSTransferSoap();
		try {
			// 
			iteminfo.setConnectType( INativeConnector.GET_DOCUMENT_LIST );
			// եΥѥ
			NativeConnectorImpl.setConfigFilePath();
			// GetDocumentList¹
			boolean rc = jxms.getDocumentList( iteminfo );
			if ( rc ) {
				iteminfo.setResultInfo( IItemInfo.STATUS_OK );
			} else {
				iteminfo.setResultInfo( IItemInfo.STATUS_DOUBLE );
			}
		} catch ( Exception ex ) {
			iteminfo.setResultInfo( IItemInfo.STATUS_NG );
			iteminfo.setRetryStatus( evaluatedForRetry( ex.getMessage() ) );
			throw ex;
		} finally {
			System.gc();
		}
	}
	
	/**
	 * $$ ǧ
	 * @param iteminfo
	 * @throws Exception
	 */
	public void confirmDocument( IItemInfo iteminfo ) throws Exception {
		JXMSTransferSoap jxms = new JXMSTransferSoap();
		try {
			// 
			iteminfo.setConnectType( INativeConnector.CONFIRM_DOCUMENT );
			// եΥѥ
			NativeConnectorImpl.setConfigFilePath();
			//	 ConfirmDocument¹
			boolean rc = jxms.confirmDocument( iteminfo );
			if ( rc ) {
				iteminfo.setResultInfo( IItemInfo.STATUS_OK );
			} else {
				iteminfo.setResultInfo( IItemInfo.STATUS_DOUBLE );
			}
		} catch ( Exception ex ) {
			iteminfo.setResultInfo( IItemInfo.STATUS_NG );
			iteminfo.setRetryStatus( evaluatedForRetry( ex.getMessage() ) );
			throw ex;
		} finally {
			System.gc();
		}
	}

	/**
	 * $$ 
	 * @param iteminfo
	 * @throws Exception
	 */
	public void cancelDocument( IItemInfo iteminfo ) throws Exception {
		JXMSTransferSoap jxms = new JXMSTransferSoap();
		try {
			// 
			iteminfo.setConnectType( INativeConnector.CANCEL_DOCUMENT );
			// եΥѥ
			NativeConnectorImpl.setConfigFilePath();
			// CancelDocument¹
			boolean rc = jxms.cancelDocument( iteminfo );
			if ( rc ) {
				iteminfo.setResultInfo( IItemInfo.STATUS_OK );
			} else {
				iteminfo.setResultInfo( IItemInfo.STATUS_NG );
			}
		} catch ( Exception ex ) {
			iteminfo.setResultInfo( IItemInfo.STATUS_NG );
			iteminfo.setRetryStatus( evaluatedForRetry( ex.getMessage() ) );
			throw ex;
		} finally {
			System.gc();
		}
	}
	
	/**
	 * $$ եɹ
	 * @throws Exception
	 */
	public boolean reloadConfigure() throws Exception {
		boolean rc = false;
		JXMSTransferSoap jxms = new JXMSTransferSoap();
		try {
			rc = jxms.reloadConfigure();
			NativeConnectorImpl.initComplete = false;
		} catch ( Exception ex ) {
			throw ex;
		} finally {
			System.gc();
		}
		return rc;
	}
	
	/**
	 * $$ ItemInfoImplեϢΥѥ򥻥å
	 * @throws Exception
	 */
	private synchronized static void setConfigFilePath() throws Exception {
		String tagName = null;
		String serverInstDir = null;
		try {
			// Ķѿ饤󥹥ȡѥ뤫ݤ
			if ( ItemInfoImpl.getRefEnvInfoFlag() ) {
//				if ( ( ItemInfoImpl.getInitConfFilePath() != null ) && ( ItemInfoImpl.getInitLogConfFilePath() != null ) ) {
				if ( ! NativeConnectorImpl.initComplete ) {
					// ꤵƤѥ٥ꥢ
					ItemInfoImpl.setInitConfFilePath(null);
					ItemInfoImpl.setInitLogConfFilePath(null);
					serverInstDir = NativeConnectorImpl.getServerInstDir();
					ItemInfoImpl.setInitConfDirectory( serverInstDir + NativeConnectorImpl.INIT_CONF_FOLDER );
					// XMLReader֥Ȥ
					XMLReader xreader = new XMLReader( ( serverInstDir + NativeConnectorImpl.WEBXML_FILE_PATH ) );
					ArrayList nlist = xreader.selectNodes("servlet/init-param/param-name");
					for (int i = 0; i < nlist.size(); i++) {
						String value = xreader.getNodeValue( (Node)nlist.get( i ) );
						if ( value.equalsIgnoreCase( "confFilePath" ) ) {
							Node targetNode = xreader.selectSingleNode( ( (Node)nlist.get( i ) ).getParentNode(), "param-value" );
							// Х⥸塼եѥ
							ItemInfoImpl.setInitConfFilePath( ItemInfoImpl.getInitConfDirectory() + xreader.getNodeValue( targetNode ) );
						}
					}
					// log4jեѥ
					ItemInfoImpl.setInitLogConfFilePath( ItemInfoImpl.getInitConfDirectory() + ItemInfoImpl.getInitLogConfFileName() );
					NativeConnectorImpl.initComplete = true;
				}
			} else {
				ItemInfoImpl.setInitConfDirectory( Constant.BLANK );
			}
		} catch ( Exception ex ) {
			NativeConnectorImpl.initComplete = false;
			throw ex;
		}
	}
	
	/**
	 * $$ ĶѿTOMCAT󥹥ȡǥ쥯ȥ
	 * @return
	 * @throws Exception
	 */
	private static String getServerInstDir() throws Exception {
		String command[] = null;
		String serverInstDir = null;
		Process proc = null;
		InputStream is = null;
		BufferedReader br = null;
		try {
			if ( File.separator.equalsIgnoreCase( NativeConnectorImpl.SLASH_STR ) ) {
				// UNIXϤΥޥɼ¹
				command = new String[3]; 
	            command[0] = ItemInfoImpl.getUnixDoCommand();
	            command[1] = ItemInfoImpl.getUnixArgSwitch();
	            command[2] = ItemInfoImpl.getUnixArgLine();
			} else {
				// WindowsϤΥޥɼ¹
				command = new String[3]; 
	            command[0] = ItemInfoImpl.getWinDoCommand();
	            command[1] = ItemInfoImpl.getWinArgSwitch();
	            command[2] = ItemInfoImpl.getWinArgLine();
			}
	        proc = Runtime.getRuntime().exec( command );
	        is = proc.getInputStream();
	        br = new BufferedReader( new InputStreamReader( is ) );
	        serverInstDir = br.readLine();
	        proc.waitFor();
	        System.out.println("Х󥹥ȡǥ쥯ȥ=" + serverInstDir);
		} catch ( Exception ex ) {
			throw ex;
		} finally {
		
		}
		return serverInstDir;
	}
	
	/**
	 * $$ ȥ饤׵ݥơ
	 * @param emsg
	 * @return
	 * @throws Exception
	 */
	private boolean evaluatedForRetry( String emsg ) throws Exception {
		boolean rc = false;
		try {
			if ( emsg == null ) {
				emsg = "";
			}
			emsg = emsg.trim();
			//	֤ΰ֤
			if ( emsg.indexOf( Constant.TAB ) >= 0 ) {
				emsg =  emsg.substring( 0, emsg.indexOf( Constant.TAB ) ).trim();
			}
			if ( emsg.indexOf( Constant.CORON ) >= 0 ) {
				emsg = emsg.substring( ( emsg.indexOf( Constant.CORON ) + 1 ) ).trim();
			}
			emsg = emsg.substring( 0, 2 );
			if ( ( emsg.equalsIgnoreCase( "SI" ) || emsg.equalsIgnoreCase( "ST" ) ) ) {
				rc = true;
			}
		} catch ( Exception ex ) {
			throw ex;
		} finally {
			
		}
		return rc;
	}
	
	/**
	 * $$ ʸ
	 * @param formatter
	 * @return ʸ
	 * @throws Exception
	 */
	public static String getCurDateString( String formatter ) throws Exception {
        Calendar cal = null;
        String now = null;
	    try {
	        // ֥ȤΥ󥹥󥹼
	        cal = Calendar.getInstance();
	        // դμ
	        now = NativeConnectorImpl.getTargetDateString( formatter, cal.getTime() );
		} catch( Exception ex ){
			throw ex;
		} finally {
		
		}
		return now;
    }
	
	/**
	 * $$ ʸեޥå
	 * @param formatter
	 * @param before
	 * @return եޥåȤ줿ʸ
	 * @throws Exception
	 */
	public static String getTargetDateString( String formatter, Date before ) throws Exception {
        SimpleDateFormat sdf = null;
        String after = null;
	    try {
	        // եեޥå
	        sdf = new SimpleDateFormat();
	        // եޥå˥եޥåȥѥŬ
	        sdf.applyPattern( formatter );
	        // դեޥåŬѤѥŬ
	        after = sdf.format( before );
		} catch( Exception ex ){
			throw ex;
		} finally {
		
		}
		return after;
    }
	
}
