package jp.webedi.sfi.bizx.server.adapter;

import java.io.File;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class XMLReader {

	private Document _xdoc = null;
	private Element _root = null;
	
	public XMLReader() {
		
	}
	
	/**
	 * $$ 󥹥ȥ饯XMLѡ
	 * @param path
	 * @throws Exception
	 */
	public XMLReader(String path) throws Exception {
		try {
			//	ե륯饹
			File file = new File(path);
			//ꤵ줿ե뤬¸ߤʤХ顼
			if(!file.exists()){
				throw new Exception("ե[" + file.getAbsolutePath() +"]¸ߤޤ");
			}
			//ꤵ줿եɹ¤̵ä饨顼
			if(!file.canRead()){
				throw new Exception("ե[" + file.getAbsolutePath() +"]ˤɤ߹߸¤ޤ");
			}
			//ɥȥӥեȥ
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			//̵Ǥ̵뤹
			factory.setIgnoringElementContentWhitespace(true);
			// ǡå
			factory.setValidating(false);
			//ɥȥӥ
			DocumentBuilder builder = factory.newDocumentBuilder();
			//ѡ¹ԤDocument֥Ȥ
			this._xdoc = builder.parse(file);
			// 롼ȥΡɤΤߥɤ
			this._root = this._xdoc.getDocumentElement();
		} catch ( Exception e ) {
			e.printStackTrace();
		}
	}
	
	/**
	 * $$ XPath˳ΡɥꥹȤ
	 * @param baseNode
	 * @param xpath
	 * @return
	 * @throws Exception
	 */
	public ArrayList selectNodes(String xpath) throws Exception {
		Node tmpNode = null;
		ArrayList retNodeList = null;
		// XPathʬ򤷤˳Ǽ
		String[] pathItems = xpath.split("/");
		// XPathΰֲ̤Υ̾ˤƥΡɸ
		NodeList nlist = this._xdoc.getElementsByTagName(pathItems[(pathItems.length - 1)]);
		if (nlist != null) {
			// ΥΡɥꥹȤ٤ƤxpathӸ
			for(int i = 0; i < nlist.getLength(); i++) {
				tmpNode = nlist.item(i);
				// XPathƥΡؤɤäxpathȹפ륿¸ߤ뤫ǧ
				for(int j = (pathItems.length - 2); j >= 0; j--) {
					tmpNode = this.getTargetParentNode(tmpNode, pathItems[j]);
					if (tmpNode == null) {
						// Ƥéʤʤä롼פȴʻΡɤ¸ߤʤ
						break;
					}
				}
				// Ƥé꤭줿餽ѥΡɥꥹȤɲ
				if ( tmpNode != null ) {
					if ( retNodeList == null ) {
						retNodeList = new ArrayList();
					}
					retNodeList.add(nlist.item(i));
				}
			}
		}
		return retNodeList;
	}
	
	/**
	 * $$ XPath˳Ρɤ
	 * @param xpath
	 * @return
	 * @throws Exception
	 */
	public Node selectSingleNode(String xpath) throws Exception {
		Node retNode = this._root;
		// XPathʬ򤷤˳Ǽ
		String[] pathItems = xpath.split("/");
		if (retNode != null) {
			// XPathҥΡؤɤäXPathȹפ륿¸ߤ뤫ǧ
			for(int i = 0; i < pathItems.length; i++) {
				retNode = this.getTargetChildNode(retNode, pathItems[i]);
				// Ҥéʤʤä롼פȴʻΡɤ¸ߤʤ
				if (retNode == null) {
					break;
				}
			}
		}
		return retNode;
	}
	
	/**
	 * $$ XPath˳Ρɤ
	 * @param baseNode
	 * @param xpath
	 * @return
	 * @throws Exception
	 */
	public Node selectSingleNode(Node baseNode, String xpath) throws Exception {
		Node retNode = baseNode;
		// XPathʬ򤷤˳Ǽ
		String[] pathItems = xpath.split("/");
		if (retNode != null) {
			// XPathҥΡؤɤäXPathȹפ륿¸ߤ뤫ǧ
			for(int i = 0; i < pathItems.length; i++) {
				retNode = this.getTargetChildNode(retNode, pathItems[i]);
				// Ҥéʤʤä롼פȴʻΡɤ¸ߤʤ
				if (retNode == null) {
					break;
				}
			}
		}
		return retNode;
	}
	
	/**
	 * $$ ƥΡɤϢʤΡɤ꥿̾ΥΡɤ
	 * @param parentNode
	 * @param tagName
	 * @return
	 * @throws Exception
	 */
	private Node getTargetChildNode(Node parentNode, String tagName) throws Exception {
		Node retNode = null;
		if (parentNode != null) {
			// ҥΡɤΥꥹȼ
			NodeList nlist = parentNode.getChildNodes();
			// ٤ƤλҥΡɤ򸡺Ρ̾Ȼ꥿̾פΡɤ֤
			for(int i = 0; i < nlist.getLength(); i++) {
				if (! nlist.item(i).getNodeName().equalsIgnoreCase("#text")) {
					if (((Node)nlist.item(i)).getNodeName().equals(tagName)) {
						retNode = (Node)nlist.item(i);
						break;
					}
				}
			}
		}
		return retNode;
	}
	
	/**
	 * $$ ΡɤοƥΡ̾꥿̾ǤпƥΡɤ
	 * @param childNode
	 * @param tagName
	 * @return
	 * @throws Exception
	 */
	private Node getTargetParentNode(Node childNode, String tagName) throws Exception {
		Node retNode = null;
		if (childNode != null) {
			// ҥΡɤοƥΡɤ
			Node pnode = childNode.getParentNode();
			// ƥΡɤΥ̾ΡɤȰפФοƥΡɤ֤
			if (pnode.getNodeName().equals(tagName)) {
				retNode = pnode;
			}
		}
		return retNode;
	}
	
	/**
	 * $$ ΡɤΥƥȡ͡ˤ
	 * @param currentNode
	 * @return
	 * @throws Exception
	 */
	public String getNodeValue(Node currentNode) throws Exception {
		String retValue = "";
		// Ρɤnullʤ㳰
		if ( currentNode == null ) {
			throw new Exception("currentNode=[" + currentNode.getNodeName() + "]¸ߤޤ");
		}
		// ҥΡɤ¸ߥå
		if ( currentNode.hasChildNodes() ) {
			// ҥΡɤ
			Node txtNode = currentNode.getFirstChild();
			// ҥΡɤƥȥΡɤȽꤷƥȥΡɤʤ֤ͤ
			if (txtNode.getNodeType() == Node.TEXT_NODE) {
				retValue = txtNode.getNodeValue();
			}
		}
		return retValue;
	}
	
}

