package jp.webedi.sfi.bizx.server.communication;

import java.math.BigDecimal;
import java.util.Hashtable;

import jp.webedi.sfi.bizx.server.commons.BizXBase;
import jp.webedi.sfi.bizx.server.commons.Constant;
import jp.webedi.sfi.bizx.server.commons.CustomException;

public class CompressType extends BizXBase {

    private Agent agent_ = null;
    private Hashtable compressTypeInfo_ = null;

    /**
     * а̥פޤ<br />
     *
     * @return а̥
     */
    public int getServerCompressType() {
        return ((BigDecimal) compressTypeInfo_.get("SERVER_COMPRESS_TYPE")).intValue();
    }

    /**
     * ̥̾Τޤ<br />
     *
     * @return ̥̾
     */
    public String getName() {
        return (String) compressTypeInfo_.get("NAME");
    }

    /**
     * ĥҤޤ<br />
     *
     * @return ĥ
     */
    public String getExtension() {
        return (String) compressTypeInfo_.get("EXTENSION");
    }

    /**
     * MIMEǥפޤ<br />
     *
     * @return MIMEǥ
     */
    public String getMimeMediaType() {
        return (String) compressTypeInfo_.get("MIME_MEDIA_TYPE");
    }

    /**
     * 󥹥󥹤ޤ
     *
     * @param agent
     * @throws Exception
     */
    public CompressType(Agent agent) throws Exception {
        super();

        try {
            this.agent_ = agent;
        } catch (Exception ex) {
            throw new CustomException(Constant.LOG_LEVEL_FATAL, ex);
        } finally {
        }
    }

    /**
     * ̥פޤ
     *
     * @param serverCompressType
     * @return
     * @throws Exception
     */
    public boolean getCompressTypeInfo(int serverCompressType)
            throws Exception {
        boolean ret = true;

        try {
            switch (serverCompressType) {
            case 1:
                compressTypeInfo_ = createCompressTypeInfo(1, "Zigzag In line Package ", "zip", "application/zip");
                break;
            case 2:
                compressTypeInfo_ = createCompressTypeInfo(2, "Java Archiver ", "jar", "application/java-archiver");
                break;
            case 3:
                compressTypeInfo_ = createCompressTypeInfo(3, "Tape Archiver ", "tar", "application/x-tar");
                break;
            case 4:
                compressTypeInfo_ = createCompressTypeInfo(4, "GNU ZIP ", "gz", "application/gzip");
                break;
            default:
                ret = false;
            }
            // } catch (CustomException ex) {
            // throw new CustomException(ex.getMessage());
        } catch (Exception ex) {
            throw new CustomException(Constant.LOG_LEVEL_ERROR, ex);
        } finally {
        }

        return ret;
    }

    /**
     * ̥פޤ
     *
     * @param mimeMediaType
     * @return
     * @throws Exception
     */
    public boolean getCompressTypeInfo(String mimeMediaType)
            throws Exception {
        boolean ret = true;

        try {
            if (mimeMediaType.equals("application/zip")) {
                compressTypeInfo_ = createCompressTypeInfo(1, "Zigzag In line Package ", "zip", "application/zip");
            } else if (mimeMediaType.equals("application/java-archiver")) {
                compressTypeInfo_ = createCompressTypeInfo(2, "Java Archiver ", "jar", "application/java-archiver");
            } else if (mimeMediaType.equals("application/x-tar")) {
                compressTypeInfo_ = createCompressTypeInfo(3, "Tape Archiver ", "tar", "application/x-tar");
            } else if (mimeMediaType.equals("application/gzip")) {
                compressTypeInfo_ = createCompressTypeInfo(4, "GNU ZIP ", "gz", "application/gzip");
            } else {
                ret = false;
            }
            // } catch (CustomException ex) {
            // throw new CustomException(ex.getMessage());
        } catch (Exception ex) {
            throw new CustomException(Constant.LOG_LEVEL_ERROR, ex);
        } finally {
        }

        return ret;
    }

    private Hashtable createCompressTypeInfo(int serverCompressType,
            String name, String extension, String mimeMediaType) {
        Hashtable c = new Hashtable();
        c.put("SERVER_COMPRESS_TYPE", BigDecimal.valueOf(serverCompressType));
        c.put("NAME", name);
        c.put("EXTENSION", extension);
        c.put("MIME_MEDIA_TYPE", mimeMediaType);

        return c;
    }
}
